SystemOrganization addCategory: #'DAO-Satellite'!

Object subclass: #Beacon
	instanceVariableNames: 'data subsystemsOrderedById'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!Beacon class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 13:03'!
newFromSubsystems: subsystems 
	^ self new initializeFromSubsystems: subsystems
! !

!Beacon methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/2/2013 22:54'!
collectTelemetry

	data :=  subsystemsOrderedById collect: [ :subsystem | subsystem telemetry ].

	^ data.
! !

!Beacon methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 11:59'!
data
	^ data! !

!Beacon methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 15:05'!
initializeFromSubsystems: subsystems
	subsystemsOrderedById := SortedCollection sortBlock: [ :current :new | current id < new id ].

	subsystemsOrderedById addAll: subsystems.		

	self collectTelemetry.
! !

Beacon subclass: #ShortBeacon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!ShortBeacon methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 15:20'!
collectTelemetry
	
	data := subsystemsOrderedById collect: [ :subsystem | subsystem shortTelemetry ].
	
	^ data.
! !

Object subclass: #Command
	instanceVariableNames: 'id parameters responseParameters executeBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!Command class methodsFor: 'cdh' stamp: 'EzequielDavidovichCaballero 10/2/2013 21:20'!
cdhDelayBeacon
	| entryParameters |
	entryParameters := OrderedCollection new.
	entryParameters add: (UnsignedIntegerCommandParameter new: 16).
	^ self new
		initializeWith: 32
		receiving: entryParameters
		responding: OrderedCollection new
		executing: [  ]! !

!Command class methodsFor: 'cdh' stamp: 'EzequielDavidovichCaballero 10/9/2013 21:27'!
cdhGetRadio
	| answerParameters |
	
	answerParameters := OrderedCollection new.
	answerParameters add: String new.
	^ self new
		initializeWith: 36
		receiving: OrderedCollection new
		responding: answerParameters
		executing: [  ]! !

!Command class methodsFor: 'cdh' stamp: 'EzequielDavidovichCaballero 10/9/2013 21:18'!
cdhSetBeaconData
	| entryParameters |
	entryParameters := OrderedCollection new.
	entryParameters add: String new.
	^ self new
		initializeWith: 35
		receiving: entryParameters
		responding: OrderedCollection new
		executing: [  ]! !

!Command class methodsFor: 'cdh' stamp: 'EzequielDavidovichCaballero 10/9/2013 21:18'!
cdhSetBeaconInterval
	| entryParameters |
	entryParameters := OrderedCollection new.
	entryParameters add: (UnsignedIntegerCommandParameter new: 8).
	^ self new
		initializeWith: 34
		receiving: entryParameters
		responding: OrderedCollection new
		executing: [  ]! !

!Command class methodsFor: 'cdh' stamp: 'EzequielDavidovichCaballero 10/9/2013 21:39'!
cdhSetRadio
	| answerParameters entryParameters enum |
	
	entryParameters := OrderedCollection new.
	entryParameters add: String new.
	enum := OrderedCollection new: 12.
	enum addAll:  ('RV_SUCCESS', 'RV_TIMEOUT', 'RV_BUSY', 'RV_ILLEGAL', 'RV_NOSPACE', 'RV_ERROR', 'RV_EXIST', 'RV_NOENT', 'RV_PERM', 'RV_PARTIAL', 'RV_NACK', 'RV_NOTIMPLEMENTED') . 
	answerParameters := OrderedCollection new.
	answerParameters add: EnumCommandParameter.
	
	^ self new
		initializeWith: 37
		receiving: entryParameters
		responding: answerParameters
		executing: [  ]! !

!Command class methodsFor: 'cdh' stamp: 'EzequielDavidovichCaballero 10/9/2013 21:18'!
cdhSet_tx_power
	| entryParameters |
	entryParameters := OrderedCollection new.
	entryParameters add: (UnsignedIntegerCommandParameter new: 8).
	^ self new
		initializeWith: 33
		receiving: entryParameters
		responding: OrderedCollection new
		executing: [  ]! !

!Command class methodsFor: 'cdh' stamp: 'EzequielDavidovichCaballero 10/9/2013 16:51'!
cdhShortTelemetry
	
		|answerParameters|

		answerParameters:= OrderedCollection new.
		answerParameters add: (UnsignedIntegerCommandParameter new: 8).


	^ self new initializeWith: 2
		receiving: OrderedCollection new
		responding: answerParameters
		executing: [ :aSubsystem |	aSubsystem shortTelemetry ]! !

!Command class methodsFor: 'cdh' stamp: 'EzequielDavidovichCaballero 10/9/2013 21:27'!
cdhTelemetry
	
		|answerParameters|

		answerParameters:= OrderedCollection new.
		answerParameters add: (UnsignedIntegerCommandParameter new: 32).
		answerParameters add: (UnsignedIntegerCommandParameter new: 32).
		answerParameters add: (UnsignedIntegerCommandParameter new: 8).

	^ self new initializeWith: 1
		receiving: OrderedCollection new
		responding: answerParameters
		executing: [ :aSubsystem |	aSubsystem telemetry ]! !

!Command class methodsFor: 'general' stamp: 'EzequielDavidovichCaballero 10/2/2013 21:58'!
getNameCommand
	
		|answerParameters|

		answerParameters:= OrderedCollection new: 1.
		answerParameters add: StringCommandParameter new.

	^ self new initializeWith: 0
		receiving: OrderedCollection new
		responding: answerParameters
		executing: [ :aSubsystem |	| data |
	
			data := OrderedCollection new.
			data add: aSubsystem name.
	
			DataCommandResponse newWithData: data. ]! !

!Command class methodsFor: 'memory' stamp: 'EzequielDavidovichCaballero 10/9/2013 15:56'!
memoryReadAddress
	
		|parameters answerParameters|

		parameters:= OrderedCollection new.
		parameters add: (UnsignedIntegerCommandParameter new: 32).
		
		answerParameters := OrderedCollection new.
		answerParameters add: (ArrayCommandParameter newWithElementType: UnsignedIntegerCommandParameter andElementSize: 8 andLength: 200).



	^ self new initializeWith: 32
		receiving: parameters
		responding: answerParameters
		executing: [ :aSubsystem |	
					
		]! !

!Command class methodsFor: 'memory' stamp: 'EzequielDavidovichCaballero 10/9/2013 20:29'!
memoryReadChunkedAddress
	
		|parameters answerParameters |

		parameters:= OrderedCollection new.
			5 timesRepeat: [ 
		parameters add: (UnsignedIntegerCommandParameter new: 32). 
	].

		answerParameters := OrderedCollection new.
		answerParameters add: (UnsignedIntegerCommandParameter new:32).
		answerParameters add: (ArrayCommandParameter newWithElementType: (UnsignedIntegerCommandParameter new: 8) andElementSize: 8 andLength: 200 ).
	


	^ self new initializeWith: 45
		receiving: parameters
		responding: answerParameters
		executing: [  ]! !

!Command class methodsFor: 'memory' stamp: 'EzequielDavidovichCaballero 10/9/2013 20:34'!
memoryReadLongAddress
	
		|parameters answerParameters|

		parameters:= OrderedCollection new.
		parameters add: (UnsignedIntegerCommandParameter new: 32).
		parameters add: (UnsignedIntegerCommandParameter new: 32).
		
		answerParameters := OrderedCollection new.
		answerParameters add: (UnsignedIntegerCommandParameter new: 32).
		answerParameters add: (ArrayCommandParameter newWithElementType: UnsignedIntegerCommandParameter andElementSize: 8 andLength: 200).



	^ self new initializeWith: 44
		receiving: parameters
		responding: answerParameters
		executing: [ :aSubsystem |	
					
		]! !

!Command class methodsFor: 'memory' stamp: 'EzequielDavidovichCaballero 10/9/2013 20:38'!
memoryShortTelemetry
	
		|parameters answerParameters|

		parameters:= OrderedCollection new.
			
		answerParameters := OrderedCollection new.



	^ self new initializeWith: 2
		receiving: parameters
		responding: answerParameters
		executing: [ :aSubsystem |	aSubsystem shortTelemetry 
					
		]! !

!Command class methodsFor: 'memory' stamp: 'EzequielDavidovichCaballero 10/9/2013 20:38'!
memoryTelemetry
	
		|parameters answerParameters|

		parameters:= OrderedCollection new.
			
		answerParameters := OrderedCollection new.
		answerParameters add: (UnsignedIntegerCommandParameter new: 32).



	^ self new initializeWith: 1
		receiving: parameters
		responding: answerParameters
		executing: [ :aSubsystem |	aSubsystem telemetry
					
		]! !

!Command class methodsFor: 'memory' stamp: 'EzequielDavidovichCaballero 10/9/2013 20:34'!
memoryWriteAddress
	
		|parameters answerParameters|

		parameters:= OrderedCollection new.
		parameters add: (UnsignedIntegerCommandParameter new: 32).
		parameters add: (StringCommandParameter new: 8).
		
		answerParameters := OrderedCollection new.



	^ self new initializeWith: 33
		receiving: parameters
		responding: answerParameters
		executing: [ :aSubsystem |	
					
		]! !

!Command class methodsFor: 'platform' stamp: 'EzequielDavidovichCaballero 10/9/2013 20:05'!
platformReset
	


	^ self new initializeWith: 33
		receiving:  OrderedCollection new
		responding: OrderedCollection new
		executing: [  ]! !

!Command class methodsFor: 'platform' stamp: 'EzequielDavidovichCaballero 10/9/2013 20:05'!
platformSetMode
	
		|parameters|

		parameters:= OrderedCollection new.
		parameters add: (UnsignedIntegerCommandParameter new: 8).


	^ self new initializeWith: 32
		receiving: parameters
		responding: OrderedCollection new
		executing: []! !

!Command class methodsFor: 'platform' stamp: 'EzequielDavidovichCaballero 10/9/2013 20:02'!
platformShortTelemetry
	
	

	^ self new initializeWith: 2
		receiving: OrderedCollection new
		responding: OrderedCollection new
		executing: [ :aSubsystem |	aSubsystem shortTelemetry ]! !

!Command class methodsFor: 'platform' stamp: 'EzequielDavidovichCaballero 10/9/2013 20:05'!
platformTelemetry

	
	| answerParameters |
	answerParameters := OrderedCollection new.
	answerParameters add: (UnsignedIntegerCommandParameter new: 64).
	answerParameters add: (UnsignedIntegerCommandParameter new: 8).

	^ self new initializeWith: 1
		receiving: OrderedCollection new
		responding: answerParameters
		executing: [ :aSubsystem |	aSubsystem telemetry ]! !

!Command class methodsFor: 'platform' stamp: 'EzequielDavidovichCaballero 10/9/2013 20:49'!
platformVersion
	|answerParameters|
	
	answerParameters := OrderedCollection new.
	answerParameters add: String new.


	^ self new initializeWith: 34
		receiving:  OrderedCollection new
		responding: answerParameters 
		executing: [  ]! !

!Command class methodsFor: 'power' stamp: 'EzequielDavidovichCaballero 10/9/2013 20:54'!
powerReset
	
	
	^ self new initializeWith: 32
		receiving: OrderedCollection new
		responding: OrderedCollection new
		executing: []! !

!Command class methodsFor: 'power' stamp: 'EzequielDavidovichCaballero 10/9/2013 19:57'!
powerShortTelemetry
	
	
	^ self new initializeWith: 2
		receiving: OrderedCollection new
		responding: OrderedCollection new
		executing: [ :aSubsystem |	aSubsystem shortTelemetry ]! !

!Command class methodsFor: 'power' stamp: 'EzequielDavidovichCaballero 10/9/2013 20:54'!
powerStbGetSwitchesState
	
	|answerParameters|
	
	answerParameters := OrderedCollection new.
	answerParameters add: (UnsignedIntegerCommandParameter new: 24).
	
	^ self new initializeWith: 35
		receiving: OrderedCollection new
		responding: answerParameters
		executing: [ :aSubsystem |	]! !

!Command class methodsFor: 'power' stamp: 'EzequielDavidovichCaballero 10/9/2013 20:54'!
powerStbSetInitialState
	
	|parameters|
	
	parameters := OrderedCollection new.
	parameters add: (UnsignedIntegerCommandParameter new: 24).
	
	^ self new initializeWith:37
		receiving: parameters 
		responding: OrderedCollection new
		executing: [ :aSubsystem |	]! !

!Command class methodsFor: 'power' stamp: 'EzequielDavidovichCaballero 10/9/2013 16:37'!
powerStbSetSwitchesState
	
		| parameters answerParameters |

	parameters := OrderedCollection new.
	parameters add: (UnsignedIntegerCommandParameter new: 24).
	
	answerParameters := OrderedCollection new.

	^ self new initializeWith: 36
		receiving: parameters
		responding: answerParameters
		executing: [ ]! !

!Command class methodsFor: 'power' stamp: 'EzequielDavidovichCaballero 10/9/2013 16:26'!
powerTelemetry
	
		|answerParameters|

		answerParameters:= OrderedCollection new.
			13 timesRepeat: [ 
		answerParameters add: (UnsignedIntegerCommandParameter new: 16). 
	].


	^ self new initializeWith: 1
		receiving: OrderedCollection new
		responding: answerParameters
		executing: [ :aSubsystem |	aSubsystem telemetry ]! !

!Command class methodsFor: 'thermal' stamp: 'EzequielDavidovichCaballero 10/9/2013 15:45'!
thermalSetMatrixKey
	
		|parameters|

		parameters:= OrderedCollection new.
		parameters add: (UnsignedIntegerCommandParameter new: 32).


	^ self new initializeWith: 32
		receiving: parameters
		responding: OrderedCollection new
		executing: [ :aSubsystem |	
					aSubsystem setMatrixKey: ((parameters at: 1) value).
					VoidCommandResponse new.
		]! !

!Command class methodsFor: 'thermal' stamp: 'EzequielDavidovichCaballero 10/9/2013 16:21'!
thermalShortTelemetry
	
		|answerParameters|

		answerParameters:= OrderedCollection new.
		answerParameters add: (UnsignedIntegerCommandParameter new: 8).


	^ self new initializeWith: 2
		receiving: OrderedCollection new
		responding: answerParameters
		executing: [ :aSubsystem |	aSubsystem shortTelemetry ]! !

!Command class methodsFor: 'thermal' stamp: 'EzequielDavidovichCaballero 10/9/2013 15:38'!
thermalTelemetry
	
		|answerParameters|

		answerParameters:= OrderedCollection new.
		answerParameters add: (SignedIntegerCommandParameter new: 16).
		answerParameters add: (SignedIntegerCommandParameter new: 16).


	^ self new initializeWith: 1
		receiving: OrderedCollection new
		responding: answerParameters
		executing: [ :aSubsystem |	aSubsystem telemetry ]! !

!Command methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 17:14'!
= aCommand
	^ id = aCommand id! !

!Command methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 13:03'!
addParameterValue: aValue
	| parameter |
	
	parameter := parameters at: (parameters findFirst: [ :p | (p value) isNil]).
	
	parameter value: aValue.
! !

!Command methodsFor: 'deserialization' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 17:24'!
deserializeResponse: serializedResponse 

	| responseData readStream sequenceNumber |

	responseParameters isEmpty ifTrue: [ ^VoidCommandResponse new. ].

	sequenceNumber := (serializedResponse first: 3) asInteger.

	readStream := ReadStream on: (serializedResponse allButFirst: 3).

	responseData := OrderedCollection new.

	responseParameters do: [ :parameter | responseData add: (parameter deserialize: readStream)].
	
	^ DataCommandResponse newWithSequenceNumber: sequenceNumber andData: responseData.
! !

!Command methodsFor: 'executing' stamp: 'EzequielDavidovichCaballero 10/2/2013 20:59'!
execute: aBlock On: aSubsystem
	
	^aBlock value: aSubsystem.! !

!Command methodsFor: 'executing' stamp: 'EzequielDavidovichCaballero 10/2/2013 22:51'!
executeOn: aSubsystem
	^ executeBlock value: aSubsystem! !

!Command methodsFor: 'accessing' stamp: 'EzequielDavidovichCaballero 9/15/2013 17:46'!
id
	^ id! !

!Command methodsFor: 'initialization' stamp: 'EzequielDavidovichCaballero 10/2/2013 21:51'!
initialize
! !

!Command methodsFor: 'initialization' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 17:47'!
initializeCommandDefinition
	self subclassResponsibility.! !

!Command methodsFor: 'initialization' stamp: 'EzequielDavidovichCaballero 10/2/2013 21:24'!
initializeWith: anId receiving: entryParameters responding: answerParameters executing: aBlock

	id := anId.
	parameters := entryParameters.
	responseParameters := answerParameters.
	executeBlock := aBlock ! !

!Command methodsFor: 'serialization' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/28/2013 11:57'!
serialize
	
	| stream |
			
	stream := WriteStream on: ByteArray new.
		
	stream nextPut: (id asByte).

	parameters do: [ :parameter |
		stream nextPutAll: (parameter serialize).
	].
	
	^ stream contents.! !

Object subclass: #CommandParameter
	instanceVariableNames: 'value bitSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

CommandParameter subclass: #ArrayCommandParameter
	instanceVariableNames: 'type arrayLength elementSize elementType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!ArrayCommandParameter class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 18:08'!
newWithElementType: type andElementSize: elementSize andLength: arrayLength
	^ self new initializeWithElementType: type andElementSize: elementSize andArrayLength: arrayLength.
	! !

!ArrayCommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 18:06'!
deserialize: aReadStream 
	| result responseParameter |
	
	result := OrderedCollection new.
	
	[aReadStream atEnd] whileFalse: [ 
		" create an object of type elementType (i.e. UnsignedIntegerCommandParameter) and size in bits elementSize"
		responseParameter := elementType new: elementSize.
		value := responseParameter deserialize: aReadStream.
		result add: value.
	 ].

	^ result.! !

!ArrayCommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 17:51'!
elementSize
	^ elementSize! !

!ArrayCommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 18:07'!
initializeWithElementType: theType andElementSize: theElementSize andArrayLength: theArrayLength
	elementType := theType.
	elementSize := theElementSize.
	arrayLength := theArrayLength.! !

!CommandParameter class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 16:03'!
new: aSize
	^ self new initializeWithBitSize: aSize! !

!CommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 16:04'!
byteSize
	^ (bitSize / 8)! !

!CommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 16:04'!
initializeWithBitSize: aSize
	bitSize := aSize! !

!CommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 14:22'!
value
	^ value! !

!CommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 14:22'!
value: aValue
	value := aValue! !

CommandParameter subclass: #EnumCommandParameter
	instanceVariableNames: 'labels'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!EnumCommandParameter class methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/9/2013 21:44'!
newWith: labels

	^self new initializeWith: labels! !

!EnumCommandParameter methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/9/2013 21:49'!
initializeWith: aCollectionOfLabels

	! !

CommandParameter subclass: #SignedIntegerCommandParameter
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!SignedIntegerCommandParameter methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/28/2013 18:21'!
deserialize: aReadstream 
	| serializedValue sign result |
	
	"take first 2 bytes from the input, first byte is sign"

	sign := aReadstream next asInteger.
	serializedValue := aReadstream next.
	result := serializedValue asInteger.
	
	(sign = 1) ifTrue: [ result := result * -1].
	
	^ result.! !

CommandParameter subclass: #StringCommandParameter
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!StringCommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 19:49'!
deserialize: aReadStream 

	^ aReadStream contents asString.
! !

!StringCommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 14:24'!
serialize 

	| valueBytes valueSize headerSize header result stream |

	valueBytes := value asByteArray.
	valueSize := valueBytes size.

	headerSize := (self byteSize).	
	header := ByteArray new: headerSize.
	header replaceFrom: (headerSize - (valueSize asByteArray size) + 1) to: headerSize with: (valueSize asByteArray).
	
	result := ByteArray new: headerSize + valueSize.
	stream := WriteStream on: result.
	stream nextPutAll: header.
	stream nextPutAll: valueBytes.

	^ result.
! !

CommandParameter subclass: #UnsignedIntegerCommandParameter
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!UnsignedIntegerCommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 18:02'!
deserialize: aReadstream 
	| serializedValue |
	
	serializedValue := aReadstream next: (self byteSize).
	
	^ serializedValue asInteger.
! !

!UnsignedIntegerCommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 14:24'!
serialize

	| valueBytes start stop result |
	
	result := ByteArray new: (self byteSize).
	
	valueBytes := value asByteArray.
	start := (result size) - (valueBytes size) + 1.
	stop := (result size).
	result replaceFrom: start to: stop with: valueBytes.
	
	^ result.
! !

Object subclass: #CommandResponse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!CommandResponse methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 19:37'!
data
	self subclassResponsibility! !

CommandResponse subclass: #DataCommandResponse
	instanceVariableNames: 'data sequenceNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!DataCommandResponse class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 20:23'!
newWithData: data
	^ self new initializeWithData: data.! !

!DataCommandResponse class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 16:54'!
newWithSequenceNumber: aSequenceNumber andData: aData
	^ self new initializeWithSequenceNumber: aSequenceNumber andData: aData.! !

!DataCommandResponse methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 19:38'!
= aResponse
	^ data = aResponse data! !

!DataCommandResponse methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 20:28'!
data
	^ data! !

!DataCommandResponse methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 20:24'!
initializeWithData: aData
	data := aData! !

!DataCommandResponse methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 16:55'!
initializeWithSequenceNumber: aSequenceNumber andData: aData 
	sequenceNumber := aSequenceNumber.
	data := aData.! !

!DataCommandResponse methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 15:55'!
sequenceNumber
	^ sequenceNumber! !

CommandResponse subclass: #VoidCommandResponse
	instanceVariableNames: 'code'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!VoidCommandResponse methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 19:17'!
= anotherResponse
	^ anotherResponse isKindOf: VoidCommandResponse! !

!VoidCommandResponse methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 19:38'!
data
	^ OrderedCollection new.! !

Object subclass: #ControllerLog
	instanceVariableNames: 'entries archive'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!ControllerLog class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 20:13'!
newWithArchive: aLogArchive 
	^ self new initializeWithArchive: aLogArchive.! !

!ControllerLog methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 16:30'!
addEntry: aControllerLogEntry 
	entries addLast: aControllerLogEntry! !

!ControllerLog methodsFor: 'recording' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 17:46'!
addRequest: aRequest withSequenceNumber: aSequenceNumber andBytes: aByteArray
	| entry |

	(self containsEntryWithSequenceNumber: aSequenceNumber) ifTrue: [
		entry := self entryWithSequenceNumber: aSequenceNumber.
		self archive: entry. ].
	
	entry := ControllerLogEntry newWithRequest: aRequest andSequenceNumber: aSequenceNumber andBytes: aByteArray.
	
	entries add: entry.
! !

!ControllerLog methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 17:43'!
addResponse: aResponse andBytes: aByteArray
	| logEntry |

	logEntry := self entryWithSequenceNumber: aResponse sequenceNumber.

	logEntry ifNil: [ 
		logEntry := ControllerLogEntry new.
		self addEntry: logEntry.
	].

	logEntry setResponse: aResponse.
	logEntry setResponseBytes:  aByteArray.
	! !

!ControllerLog methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 17:54'!
addResponse: aResponse withSequenceNumber: aSequenceNumber andBytes: aByteArray
	| logEntry |

	(self isBeaconOrShortBeacon: aSequenceNumber) ifTrue: [
		logEntry := ControllerLogEntry new.
		entries addLast: logEntry.
	] ifFalse: [
		logEntry := self entryWithSequenceNumber: aSequenceNumber.
	].

	logEntry setResponse: aResponse.
	logEntry setResponseBytes:  aByteArray.! !

!ControllerLog methodsFor: 'recording' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 23:12'!
archive
	^ archive! !

!ControllerLog methodsFor: 'recording' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 16:21'!
archive: anEntry
	archive add: anEntry.
	entries remove: anEntry.! !

!ControllerLog methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 16:14'!
containsEntryWithSequenceNumber: aNumber 
	^ (self entryWithSequenceNumber: aNumber) isNil not.! !

!ControllerLog methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 16:12'!
entries
	^ entries! !

!ControllerLog methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 16:35'!
entryWithSequenceNumber: aNumber 
	| result |
	
	result := entries select: [ :entry | entry sequenceNumber = aNumber ].
	
	(result size = 0) ifTrue: [ ^ nil ].
	
	^ result first.! !

!ControllerLog methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 16:11'!
initialize
	entries := OrderedCollection new.
	archive := LinkedList new.! !

!ControllerLog methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 16:50'!
isBeaconOrShortBeacon: aSequenceNumber
	^ (aSequenceNumber = 16rFFFFF0) or: [ aSequenceNumber = 16rFFFFF3 ]
! !

!ControllerLog methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 16:11'!
isEmpty
	^ entries size = 0.! !

Object subclass: #ControllerLogEntry
	instanceVariableNames: 'sequenceNumber request time response requestBytes responseBytes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

ControllerLogEntry class
	instanceVariableNames: 'time sequenceNumber request'!

ControllerLogEntry class
	instanceVariableNames: 'time sequenceNumber request'!

!ControllerLogEntry class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 17:46'!
newWithRequest: aRequest andSequenceNumber: aSequenceNumber andBytes: aByteArray
	^ self new initializeWithRequest: aRequest andSequenceNumber: aSequenceNumber andBytes: aByteArray.! !

!ControllerLogEntry methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 17:47'!
initializeWithRequest: aRequest andSequenceNumber: aSequenceNumber andBytes: aByteArray
	time := DateAndTime now.
	request := aRequest.
	sequenceNumber := aSequenceNumber.
	requestBytes := aByteArray.! !

!ControllerLogEntry methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 20:42'!
request
	^ request
! !

!ControllerLogEntry methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 17:48'!
requestBytes
	^ requestBytes! !

!ControllerLogEntry methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 22:20'!
response
	^ response! !

!ControllerLogEntry methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 17:44'!
responseBytes
	^ responseBytes! !

!ControllerLogEntry methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 16:16'!
sequenceNumber
	^ sequenceNumber! !

!ControllerLogEntry methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 22:21'!
setResponse: aResponse
	response := aResponse.! !

!ControllerLogEntry methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 17:43'!
setResponseBytes: aResponseByteArray
	responseBytes := aResponseByteArray.! !

!ControllerLogEntry methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 20:35'!
time
	^ time! !

Object subclass: #MacGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

MacGenerator subclass: #MD5MacGenerator
	instanceVariableNames: 'sequenceNumber serializedCommandCall'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!MD5MacGenerator class methodsFor: 'key' stamp: 'NahuelGarbezza 5/18/2013 09:41'!
key

	"
	'Generate a random binary key' asByteArray adding 16r00 up to 32 len
	"
	
	^ #[71 101 110 101 114 97 116 101 32 97 32 114 97 110 100 111 109 32 98 105 110 97 114 121 32 107 101 121 00 00 00 00]! !

!MD5MacGenerator methodsFor: 'initialization' stamp: 'HernanWilkinson 3/25/2013 14:54'!
initializeFor: aSerializedCommandCall with: aSequenceNumber

	serializedCommandCall := aSerializedCommandCall.
	sequenceNumber := aSequenceNumber.
! !

!MD5MacGenerator methodsFor: 'evaluating - private' stamp: 'HernanWilkinson 3/25/2013 15:36'!
macFrom: md5

	| mac |
	
	mac := md5 first: 3.
	mac swap: 1 with: 3.
	^ mac! !

!MD5MacGenerator methodsFor: 'evaluating - private' stamp: 'NahuelGarbezza 5/18/2013 09:40'!
md5For: aStream

	aStream reset.
	^ MD5 hashStream: aStream! !

!MD5MacGenerator methodsFor: 'evaluating - private' stamp: 'NahuelGarbezza 5/18/2013 09:41'!
streamToCalculateMD5

	| stream |
	stream := ReadWriteStream on: ByteArray new.
	stream
		nextPutAll: self key;
		nextPut: (sequenceNumber bitAnd: 16rFF);
		nextPut: ((sequenceNumber digitAt: 2) bitAnd: 16rFF);
		nextPut: ((sequenceNumber digitAt: 3) bitAnd: 16rFF);
		nextPut: ((sequenceNumber digitAt: 4) bitAnd: 16rFF);
		nextPutAll: serializedCommandCall.
	^ stream! !

!MD5MacGenerator methodsFor: 'evaluating' stamp: 'HernanWilkinson 3/25/2013 15:21'!
value

	| stream md5 mac |
	
	stream := self streamToCalculateMD5.
	md5 := self md5For: stream.
	mac := self macFrom: md5.
	
	^ mac
	! !

!MacGenerator class methodsFor: 'instance creation' stamp: 'NahuelGarbezza 5/18/2013 09:41'!
for: aSerializedCommandCall with: aSequenceNumber

	^ self new initializeFor: aSerializedCommandCall with: aSequenceNumber! !

!MacGenerator class methodsFor: 'key' stamp: 'HernanWilkinson 3/25/2013 14:57'!
key

	self subclassResponsibility ! !

!MacGenerator methodsFor: 'initialization' stamp: 'HernanWilkinson 3/25/2013 14:53'!
initializeFor: aSerializedCommandCall with: aSequenceNumber 

	self subclassResponsibility ! !

!MacGenerator methodsFor: 'evaluating' stamp: 'NahuelGarbezza 5/18/2013 09:40'!
key

	^ self class key! !

!MacGenerator methodsFor: 'evaluating' stamp: 'HernanWilkinson 3/25/2013 14:53'!
value

	self subclassResponsibility ! !

Object subclass: #Satellite
	instanceVariableNames: 'subsystems'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!Satellite class methodsFor: 'instance creation' stamp: 'EmilianoMenendez 9/7/2013 16:27'!
newWithSubsystems: theSubsystems 
	^ self new initalizeWithSubsystems: theSubsystems! !

!Satellite methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/13/2013 14:45'!
commandWithId: aCommandId andSubsystemId: aSubsystemId
	| subsystem |
	
	subsystem := self subsystemWithId: aSubsystemId.
	
	aCommandId = 0 ifTrue: [ ^Command getNameCommand. ].
! !

!Satellite methodsFor: 'messaging' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 13:02'!
emitBeacon
	^ Beacon newFromSubsystems: subsystems.
! !

!Satellite methodsFor: 'messaging' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 15:13'!
emitShortBeacon
	^ ShortBeacon newFromSubsystems: subsystems.

	
	! !

!Satellite methodsFor: 'initialization' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 16:11'!
initalizeWithSubsystems: theSubsystems

	subsystems := theSubsystems.


! !

!Satellite methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 17:29'!
receive: aByteArray 
	| readStream sequence subsystemId commandId command |
	
	readStream := ReadStream on: aByteArray.

	"discard MAC"
	readStream next: 3.
	
	sequence := (readStream next: 3) asInteger.
	subsystemId := readStream next asInteger.
	commandId := readStream next asInteger.
	
	command := self commandWithId: commandId andSubsystemId: subsystemId.
	
	"TODO: read parameters from stream and set them into the command"
	
	^ command.
! !

!Satellite methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 17:23'!
subsystemWithId: aSubsystemId
	^ subsystems detect: [ :subsystem | subsystem id = aSubsystemId ].
! !

!Satellite methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/9/2013 19:59'!
subsystems
	
	^ subsystems
! !

Object subclass: #SatelliteController
	instanceVariableNames: 'radio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!SatelliteController class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 10:22'!
newWith: aRadio
	^ self new initializeWith: aRadio! !

!SatelliteController methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 18:58'!
encode: aCommand forSubsystem: subsystem withSequenceNumber: aSequenceNumber
	| subsystemId encodedCommand encodedBytes stream sequenceNumberByteArray sequenceNumberParameter macGenerator mac |

	subsystemId := subsystem id.

	encodedCommand := aCommand serialize.

	macGenerator := MD5MacGenerator for: encodedCommand with: aSequenceNumber.
	mac := macGenerator value.
		
	sequenceNumberParameter := UnsignedIntegerCommandParameter new: 24.
	sequenceNumberParameter value: (aSequenceNumber number).
	
	sequenceNumberByteArray := sequenceNumberParameter serialize.
	
	encodedBytes := ByteArray new: (mac asByteArray size) + (sequenceNumberByteArray size) + (subsystemId asByteArray size) + (encodedCommand size).
	
	stream := WriteStream on: encodedBytes.
	
	stream nextPutAll: mac asByteArray.
	stream nextPutAll: sequenceNumberByteArray.
	stream nextPutAll: subsystemId asByteArray.
	stream nextPutAll: encodedCommand.
	
	^ encodedBytes.! !

!SatelliteController methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 10:22'!
initializeWith: aRadio 
	radio := aRadio! !

!SatelliteController methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 10:21'!
shutdown 
	radio shutdown.
! !

Object subclass: #SatelliteControllerRadio
	instanceVariableNames: 'stream packageQueue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!SatelliteControllerRadio class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 10:10'!
new
	^ self openConnectionToHostNamed: 'localhost' port: 4445.
! !

!SatelliteControllerRadio methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 12:17'!
initialize
	packageQueue := LinkedList new.
	
	stream := SocketStream openConnectionToHostNamed: 'localhost' port: 4445. 
	stream binary.

	self waitForPackage.
! !

!SatelliteControllerRadio methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 13:35'!
isPackageAvailable
	^ packageQueue isEmpty not.

! !

!SatelliteControllerRadio methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 12:32'!
nextPackage
	packageQueue ifEmpty: [self waitForPackage].
	^ packageQueue removeFirst.
! !

!SatelliteControllerRadio methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 12:23'!
readPackageFromStream
	| packageSize package |
	
	packageSize :=  stream next.
	
	packageSize := (packageSize bitShift: 8) + stream next.
	packageSize := (packageSize bitShift: 8) + stream next.
	packageSize := (packageSize bitShift: 8) + stream next.
	
	package := stream next: packageSize.
	
	packageQueue add: package.
! !

!SatelliteControllerRadio methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 10:21'!
shutdown
	stream close.
! !

!SatelliteControllerRadio methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 10/13/2013 12:26'!
waitForPackage
	[true] whileTrue: [
		[stream isDataAvailable ] whileFalse: [ (Delay forSeconds: 1) wait ].
		self readPackageFromStream.
	] fork.
! !

Object subclass: #SequenceNumber
	instanceVariableNames: 'number lastNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

SequenceNumber class
	instanceVariableNames: 'number'!

SequenceNumber class
	instanceVariableNames: 'number'!

!SequenceNumber class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/20/2013 17:36'!
startingFrom: aNumber
	^ self new initializeWithStart: aNumber! !

!SequenceNumber methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/15/2013 19:08'!
asByteArray
	| resultSize resultBytes sequenceNumber start |

	resultSize := 3.

	resultBytes := ByteArray new: resultSize.
	
	sequenceNumber := number asByteArray.

	start := (resultSize - (sequenceNumber size) + 1).

	^ resultBytes replaceFrom: start to: resultSize with: sequenceNumber. 
! !

!SequenceNumber methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/27/2013 12:55'!
bitAnd: aSmallInteger 
	^number bitAnd: aSmallInteger ! !

!SequenceNumber methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/27/2013 12:56'!
digitAt: aSmallInteger 
	^number bitAnd: aSmallInteger ! !

!SequenceNumber methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/15/2013 21:14'!
initialize
	number := 1.
	lastNumber := LargePositiveInteger readFrom: 'FFFFEF' base: 16.
! !

!SequenceNumber methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/15/2013 14:58'!
initializeWithStart: aNumber
	self initialize.
	number := aNumber.! !

!SequenceNumber methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/15/2013 14:53'!
next
	number := number + 1.
	number > lastNumber ifTrue: [ self reset. ].
	^ number.
! !

!SequenceNumber methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/15/2013 15:00'!
number
	^ number! !

!SequenceNumber methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/15/2013 14:52'!
reset
	number := 1.! !

Object subclass: #Subsystem
	instanceVariableNames: 'id data telemetryKeys shortTelemetryKeys name commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!Subsystem class methodsFor: 'instantiation' stamp: 'EzequielDavidovichCaballero 10/13/2013 15:32'!
cdh
	| shortTkeys tKeys cmds |
	
	tKeys := Set new.
	tKeys add: 'lastSeenSequenceNumber'.
	tKeys add: 'nextBeaconEnableTicks'.
	tKeys add: 'antennaDeployStatus'.
	
	shortTkeys := Set new.
	shortTkeys add: 'ticksLow'.
	
	cmds:= Dictionary new.
	cmds at: 'name' put: Command getNameCommand .
	cmds at: 'telemetry' put: Command cdhTelemetry.
	cmds at: 'short_telemetry' put: Command cdhShortTelemetry.
	cmds at: 'delay_beaconSeconds' put: Command cdhDelayBeacon.
	cmds at: 'set_beacon_intervalSeconds' put: Command cdhSetBeaconInterval.
	cmds at: 'set_tx_powerr' put: Command cdhSet_tx_power.
	cmds at: 'set_beaconData' put: Command cdhSetBeaconData.
	cmds at: 'get_radio' put: Command cdhGetRadio.
	cmds at: 'set_radioConfig' put: Command cdhSetRadio.
	

	^self new initializeWithId: 4 andName: 'CDH' andTelemetryKeys: tKeys andShortTelemetryKeys: shortTkeys andCommands: Dictionary new.
! !

!Subsystem class methodsFor: 'instantiation' stamp: 'EzequielDavidovichCaballero 10/13/2013 00:13'!
memory
	
	|tKeys shortTKeys cmds |
	
	tKeys := Set new.
	tKeys add: 'free'.
	
	shortTKeys := Set new.

	cmds := Dictionary new.
	cmds at: 'name' put: Command getNameCommand.
	cmds at: 'telemetry' put: Command memoryTelemetry.
	cmds at: 'short_telemetry' put: Command memoryShortTelemetry.
	cmds at: 'readAdress' put: Command memoryReadAddress.
	
 	^self new initializeWithId: 1 andName: 'MEMORY' andTelemetryKeys: tKeys andShortTelemetryKeys: shortTKeys andCommands: cmds.! !

!Subsystem class methodsFor: 'instantiation' stamp: 'EzequielDavidovichCaballero 10/13/2013 00:15'!
platform

	| tKeys shortTKeys cmds |
	
	tKeys := Set new.
	tKeys add: 'tick_count'.
	tKeys add: 'current_mode'.
	
	shortTKeys := Set new.
	
	cmds:= Dictionary new.
	cmds at: 'name' put: Command getNameCommand.
	cmds at: 'telemetry' put: Command platformTelemetry.
	cmds at: 'short_telemetry' put: Command platformShortTelemetry.
	cmds at: 'setMode' put: Command platformSetMode.
	cmds at: 'reset' put: Command platformReset.
	cmds at: 'version' put: Command platformVersion.
	
	^self new initializeWithId: 0 andName: 'PLATFORM' andTelemetryKeys: tKeys andShortTelemetryKeys: shortTKeys andCommands: cmds.! !

!Subsystem class methodsFor: 'instantiation' stamp: 'EzequielDavidovichCaballero 10/13/2013 19:20'!
power

	| tKeys shortTKeys cmds |
	
	tKeys := Set new.
	tKeys add: 'low_voltage_counter'.
	tKeys add: 'battery_v'.
	tKeys add: 'array_X_v'.
	tKeys add: 'array_Xp_mA'.
	tKeys add: 'array_Xm_mA'.
	tKeys add: 'array_Y_v'.
	tKeys add: 'array_Yp_mA'.
	tKeys add: 'array_Y_mA'.
	tKeys add: 'array_Z_v'.
	tKeys add: 'array_Zp_mA'.
	tKeys add: 'array_Zm_mA'.
	tKeys add: '_3v3_mA'.
	tKeys add: '_5v_mA'.
	
	shortTKeys := Set new.
	
	cmds:= Dictionary new.
	cmds at: 'name' put: Command getNameCommand.
	cmds at: 'telemetry' put: Command powerTelemetry.
	cmds at: 'short_telemetry' put: Command powerShortTelemetry.
	cmds at: 'stbGetSwitchesState' put: Command powerStbGetSwitchesState.
	cmds at: 'reset' put: Command powerReset.
	cmds at: 'stbGetSwitches' put: Command powerStbSetSwitchesState.
	cmds at: 'stbSetInitialState' put: Command powerStbSetInitialState.
	
	^self new initializeWithId: 2 andName: 'POWER' andTelemetryKeys: tKeys andShortTelemetryKeys: shortTKeys andCommands: cmds.! !

!Subsystem class methodsFor: 'instantiation' stamp: 'EzequielDavidovichCaballero 10/13/2013 19:12'!
thermal

	| cmds shortTkeys tKeys |
	
	tKeys := Set new.
	tKeys add: 'battery_temp'.
	tKeys add: 'radio_temp'.
	
	shortTkeys := Set new.
	shortTkeys add: 'battery_temp'.
	
	cmds := Dictionary new.
	cmds at: 'name' put: Command getNameCommand.
	cmds at: 'telemetry' put: Command thermalTelemetry.
	cmds at: 'short_telemetry' put: Command thermalShortTelemetry.
	cmds at: 'setMatrixKey' put: Command thermalSetMatrixKey.
	
	
	^self new initializeWithId: 3 andName: 'THERMAL' andTelemetryKeys: tKeys andShortTelemetryKeys: shortTkeys andCommands: cmds.
	
! !

!Subsystem methodsFor: 'command' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/14/2013 16:35'!
= anObject
	^ id = anObject id! !

!Subsystem methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/9/2013 18:27'!
commands
	^ commands! !

!Subsystem methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/14/2013 16:03'!
getValueOfAttribute: aKey
	^ (data at: aKey)! !

!Subsystem methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/9/2013 16:10'!
id
	^ id! !

!Subsystem methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/28/2013 21:27'!
initializeWithId: theId andName: theName andTelemetryKeys: theTelemetryKeys andShortTelemetryKeys: theShortTelemetryKeys andCommands: theCommands
	id := theId.
	name := theName.
	commands := theCommands.
	telemetryKeys := theTelemetryKeys.
	shortTelemetryKeys := theShortTelemetryKeys.
	data := Dictionary new.! !

!Subsystem methodsFor: 'command' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/9/2013 16:11'!
name
	^ name! !

!Subsystem methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/14/2013 12:46'!
setAttribute: aKey withValue: aValue 
	data at: aKey put: aValue! !

!Subsystem methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/2/2013 16:05'!
setMatrixKey: theValue
	data at: 'matrix_key' put: theValue! !

!Subsystem methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/2/2013 16:05'!
setMode: theValue
	data at: 'current_mode' put: theValue! !

!Subsystem methodsFor: 'command' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 19:34'!
shortTelemetry
	| result |
	
	result := OrderedCollection new.
	
	shortTelemetryKeys do: [ :key | result add: (data associationAt: key)].
	
	^ DataCommandResponse newWithData: result
	
	
	
	! !

!Subsystem methodsFor: 'command' stamp: 'EzequielDavidovichCaballero 10/2/2013 22:54'!
telemetry
	| result |
	
	result := OrderedCollection new.
	
	telemetryKeys do: [ :key | result add: (data associationAt: key)].
	
	^ DataCommandResponse newWithData: result! !

!Subsystem methodsFor: 'accessing' stamp: 'EzequielDavidovichCaballero 9/29/2013 17:30'!
understands: aCommand
	^ (commands keys includes: aCommand).! !
